import { QueryHandler } from '@nestjs/cqrs';
import { ICollection } from 'src/modules/database/src/interfaces/collection.interface';
import { TerritoriesRepository } from '../../adapters/secondaries/territories.repository';
import { FindForPointQuery } from '../../queries/find-for-point.query';
import { Territory } from '../entities/territory';

@QueryHandler(FindForPointQuery)
export class FindForPointUseCase {
  constructor(private readonly _repository: TerritoriesRepository) {}

  async execute(
    findForPointQuery: FindForPointQuery,
  ): Promise<ICollection<Territory>> {
    return this._repository.findAll(1, 999999, {
      lon: findForPointQuery.lon,
      lat: findForPointQuery.lat,
    });
  }
}
